package org.itscool.stylist.io;

import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;

import org.itscool.commons.util.ServletTagUtil;
import org.itscool.commons.util.TagUtil;
import org.itscool.stylist.tag.HtmlAttribute;
import org.itscool.stylist.tag.HtmlTag;

/**
 * XHTMLɊ܂܂^Ȏf[^ɕϊ܂
 * @author kano
 * @version 1.00A 2006/08/09 VK쐬
 */
public class HtmlAttributeConverter extends HtmlConverter{
	/**
	 * CX^X̏s܂
	 * @param context ServletContextCX^X
	 * @param req HttpServletRequestCX^X
	 */
	public HtmlAttributeConverter(ServletContext context, HttpServletRequest req){
		super(context, req);
	}
	
	/**
	 * pXHTMLf[^̍쐬Jn܂
	 * @param node HtmlTagCX^X
	 * @return f[^
	 */
	public String convert(HtmlTag node){
		StringBuffer sb = new StringBuffer();
		ArrayList attrList = node.getAttributeList();
		int size = attrList.size();
		
		for(int i=0; i<size; i++){
			HtmlAttribute attr = (HtmlAttribute)attrList.get(i);
			String attrName = attr.getName();
			sb.append(" ").append(attrName);
			sb.append("=");
			sb.append("\"");
			String value = attr.getValue();
			if( attr.getName().equals(HtmlAttribute.ACTION) || 
				attr.getName().equals(HtmlAttribute.HREF) || 
				attr.getName().equals(HtmlAttribute.SRC) ||
				attr.getName().equals(HtmlAttribute.BGD)){
				value = convertRealPath(value);
//				sb.append(value);	
//			}else{
//				Object stack = (Object)ServletTagUtil.findValue(context, req, attr.getValue(), null);
//				if(stack==null){
//					stack = "";
//				}
//				sb.append(stack);
			}
			//ELƃeLXgɕ
			ArrayList tagList = parseEl(value);
			//EL̓WJs
			sb.append(parseText(tagList));
			sb.append("\"");
		}
		
		if( isCheckbox(node) ){
			//checkbox^ȌꍇA"checked"̗L𔻒
			String name = node.getAttribute(HtmlAttribute.W_NAME);
			String property = node.getAttribute(HtmlAttribute.W_PROPERTY);
			Object object = ServletTagUtil.findProperty(context, req, name, property, null);
			String value = node.getAttribute(HtmlAttribute.VALUE);
			if( TagUtil.isCheckedValue(object, value) ){
				sb.append(" checked=\"true\"");
			}
		}else if( isOption(node) ){
			//option^ȌꍇA"selected"̗L𔻒
			if( isParentSelect(node) ){
				//ẽ^O"select"̏ꍇAselectŎw肳ꂽloption^O̒lr
				HtmlTag parent = node.getParent();
				String name = parent.getAttribute(HtmlAttribute.W_NAME);
				String property = parent.getAttribute(HtmlAttribute.W_PROPERTY);
				Object object = ServletTagUtil.findProperty(context, req, name, property, null);
				String value = node.getAttribute(HtmlAttribute.VALUE);
				if( TagUtil.isCheckedValue(object, value) ){
					sb.append(" selected=\"true\"");
				}
			}else{
				//ẽ^O"select"ȊȌꍇAgɎw肳ꂽloption^O̒lr
				String name = node.getAttribute(HtmlAttribute.W_NAME);
				String property = node.getAttribute(HtmlAttribute.W_PROPERTY);
				Object object = ServletTagUtil.findProperty(context, req, name, property, null);
				String value = node.getAttribute(HtmlAttribute.VALUE);
				if( TagUtil.isCheckedValue(object, value) ){
					sb.append(" selected=\"true\"");
				}
			}
		}
		return sb.toString();
	}
	
	/**
	 * ̑܂ރ^O`FbN{bNXł邩ׂ܂
	 * @param node ̑ɑΉ^O
	 * @return `FbN{bNX̏ꍇtrueԂ܂
	 */
	protected boolean isCheckbox(HtmlTag node){
		if( node.getTagName().toLowerCase().equals(HtmlAttribute.INPUT) == false ){
			return false;
		}
		HtmlAttribute type = node.getHtmlAttribute(HtmlAttribute.TYPE);
		if( type == null ){
			return false;
		}
		String checkbox = type.getValue();
		if( checkbox.toLowerCase().equals(HtmlAttribute.CHECKBOX)
		|| checkbox.toLowerCase().equals(HtmlAttribute.RADIO)){
			return true;
		}else{
			return false;
		}
	}
	
	/**
	 * ̑܂ރ^OIvVł邩ׂ܂
	 * @param node ̑ɑΉ^O
	 * @return IvV̏ꍇtrueԂ܂
	 */
	protected boolean isOption(HtmlTag node){
		return node.getTagName().toLowerCase().equals(HtmlAttribute.OPTION);
	}
	
	/**
	 * ̑܂ރ^O̐eZNg^Oł邩ׂ܂
	 * @param node ̑܂ރ^O̐e^O
	 * @return ZNg^ȌꍇtrueԂ܂
	 */
	protected boolean isParentSelect(HtmlTag node){
		HtmlTag parent = node.getParent();
		return parent.getTagName().toLowerCase().equals(HtmlTag.TAG_SELECT);
	}
	
	/**
	 * ΃pXWebAvP[Ṽ[g̐΃pXɕϊ
	 * (΃pX̎w@=./../..̂悤ɓ./邱)
	 * @param url URL
	 * @return WebAvP[Ṽ[g̐΃pXɕϊURLԂ܂
	 */
	public String convertRealPath(String pUrl){
		String contextPath = req.getContextPath();
        String realPath = "";
        String url = pUrl;
        int firstIndex = url.indexOf("./");
		if( firstIndex == 0 ){
			url = url.substring(firstIndex+2);
			
			int index = url.indexOf("../");
			List pathList = getPathList();
			int listNum = pathList.size();
			String pathListStr = "/";
			if( listNum >= 3 ){
				for(int i=0; index == 0 || (i+3) < listNum; i++ ){
					url = url.substring(index+2);
					pathListStr += (String)pathList.get(listNum - (i+3));
					index = url.indexOf("../");
					if(index == 0){
						pathListStr += "/";
					}
	//				if( i==0 ){
	//					pathListStr = "/" + pathListStr;
	//				}
				}
				realPath = contextPath + pathListStr + url;
			}else{
				realPath = pUrl;
			}
			
		}else{
//			Object obj = ServletTagUtil.findValue(context, req, url, null);
//			if( obj != null ){
//				realPath = obj.toString();
//			}else{
//				realPath = "";
//			}
			return pUrl;
		}
        return realPath;
	}
	
	public List getPathList(){
		String sPath = req.getServletPath();
		ArrayList list = new ArrayList();
		StringTokenizer st = new StringTokenizer(sPath, "/");
		while(st.hasMoreTokens()){
			String name = (String)st.nextElement();
			list.add(name);
		}
		return list;
	}
}
